#ifndef _USB2894_DEVICE_
#define _USB2894_DEVICE_

#include<windows.h>

//***********************************************************
// ADɼĲṹ
typedef struct _USB2894_PARA_AD
{
	LONG Frequency;         // ɼƵ,λΪHz, [1, 750000]
	LONG InputRange[8];		// ģѡ
	LONG Gains[8];			// 
	LONG M_Length;          // Mγ(), ܵȡֵΧ1-8M, MNȲܴ8M
	LONG N_Length;          // Nγ(), ܵȡֵΧ1-8M, MNȲܴ8M
	LONG TriggerMode;		// ģʽѡ
	LONG TriggerSource;		// Դѡ
	LONG TriggerDir;		// ѡ(/򴥷)
	LONG TrigLevelVolt;		// ƽ(10000mV)
	LONG ClockSource;		// ʱԴѡ(/ʱԴ)
	LONG bClockOutput;      // ʱCLKOUT,=TRUE:ʱ, =FALSE:ֹʱ
} USB2894_PARA_AD, *PUSB2894_PARA_AD;

//***********************************************************
// ADUSB2894_PARA_ADеGains[x]ʹõӲѡ
const long USB2894_GAINS_1MULT			= 0x00; // 1
const long USB2894_GAINS_2MULT			= 0x01; // 2
const long USB2894_GAINS_4MULT			= 0x02; // 4
const long USB2894_GAINS_8MULT			= 0x03; // 8

//***********************************************************
// ADӲUSB2894_PARA_ADеInputRangeʹõѡ
const long USB2894_INPUT_N10000_P10000mV= 0x00; // 10000mV
const long USB2894_INPUT_N5000_P5000mV	= 0x01; // 5000mV
const long USB2894_INPUT_0_P10000mV		= 0x02; // 010000mV
const long USB2894_INPUT_0_P5000mV		= 0x03; // 05000mV

//***********************************************************
// ADӲUSB2894_PARA_ADеTriggerModeԱʹôģʽѡ
const long USB2894_TRIGMODE_MIDL		= 0x00; // м䴥
const long USB2894_TRIGMODE_POST		= 0x01; // 󴥷
const long USB2894_TRIGMODE_PRE			= 0x02; // Ԥ
const long USB2894_TRIGMODE_DELAY		= 0x03; // Ӳʱ

//***********************************************************
// ADӲUSB2894_PARA_ADеTriggerSourceԴźʹõѡ
const long USB2894_TRIGMODE_SOFT		= 0x00; // 
const long USB2894_TRIGSRC_DTR			= 0x01; // ѡDTRΪԴ
const long USB2894_TRIGSRC_ATR			= 0x02; // ѡATRΪԴ
const long USB2894_TRIGSRC_TRIGGER		= 0x03; // TriggerźŴڶ࿨ͬ

//***********************************************************
// ADӲUSB2894_PARA_ADеTriggerDirʹõѡ
const long USB2894_TRIGDIR_NEGATIVE		= 0x00; // 򴥷(͵ƽ/½ش)
const long USB2894_TRIGDIR_POSITIVE		= 0x01; // 򴥷(ߵƽ/ش)
const long USB2894_TRIGDIR_POSIT_NEGAT	= 0x02; // 򴥷(/͵ƽ/½ش)

//***********************************************************
// ADӲUSB2894_PARA_ADеClockSourceʱԴʹõѡ
const long USB2894_CLOCKSRC_IN			= 0x00; // ڲʱӶʱ
const long USB2894_CLOCKSRC_OUT			= 0x01; // ⲿʱӶʱ(ʹCN1ϵCLKINź)

//*************************************************************************************
// ADʵӲ
typedef struct _USB2894_STATUS_AD     
{
	LONG bADEanble;	// ADǷѾʹܣ=TRUE:ʾʹܣ=FALSE:ʾδʹ
	LONG bTrigger;  // ADǷ񱻴=TRUE:ʾѱ=FALSE:ʾδ
	LONG bComplete; // ADǷתǷ=TRUE:ʾѽ=FALSE:ʾδ
	LONG bAheadTrig;// ADǷǰ=TRUE:ʾǰ=FALSE:ʾδǰ
	LONG lEndAddr;	// ɵĽַ
} USB2894_STATUS_AD, *PUSB2894_STATUS_AD;

//***********************************************************
// ӿ
#ifndef _USB2894_DRIVER_
#define DEVAPI __declspec(dllimport)
#else
#define DEVAPI __declspec(dllexport)
#endif

#ifdef __cplusplus
extern "C" {
#endif
	//######################## ͨú #################################
	HANDLE DEVAPI FAR PASCAL USB2894_CreateDevice(int DeviceLgcID = 0); // 豸(úʹϵͳ߼豸ID
	HANDLE DEVAPI FAR PASCAL USB2894_CreateDeviceEx(LONG DevicePhysID); // 豸(úʹID255
	BOOL DEVAPI FAR PASCAL USB2894_SetDevicePhysID(HANDLE hDevice, LONG DevicePhysID); // õǰ豸ID,ϵ
	BOOL DEVAPI FAR PASCAL USB2894_GetDeviceCurrentID(HANDLE hDevice, PLONG DevicePhysID); // ȡõǰ豸ID
	BOOL DEVAPI FAR PASCAL USB2894_ResetDevice(HANDLE hDevice);		 // λUSB豸
    BOOL DEVAPI FAR PASCAL USB2894_ReleaseDevice(HANDLE hDevice);    // 豸

	//####################### ADݶȡ #################################
	BOOL DEVAPI FAR PASCAL USB2894_ADCalibration(				// ADԶУ׼
									HANDLE hDevice);			// 豸,CreateDevice
	
    BOOL DEVAPI FAR PASCAL USB2894_InitDeviceAD(				// ʼ豸,TRUE,豸̿ʼ.
									HANDLE hDevice,				// 豸,ӦCreateDevice
									PUSB2894_PARA_AD pADPara);  // Ӳ, ڴ˺оӲ״̬	

	BOOL DEVAPI FAR PASCAL USB2894_StartDeviceAD(				// ڳʼ֮豸
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB2894_SetDeviceTrigAD(				// 豸ʹ󣬲¼ֻдԴΪʱЧ
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB2894_GetDevStatusAD(				// ȡADɼ״̬
									HANDLE hDevice,				// 豸
									PUSB2894_STATUS_AD pADStatus);// AD״̬

	ULONG DEVAPI FAR PASCAL USB2894_GetSDRAMSize(				// ذDDR2СλΪMb
									HANDLE hDevice);			// 豸

	BOOL DEVAPI FAR PASCAL USB2894_StopDeviceAD(				// 豸֮ͣ豸
									HANDLE hDevice);			// 豸

    BOOL DEVAPI FAR PASCAL USB2894_ReadDeviceAD(				// ʼ豸󣬼ô˺ȡ豸ϵAD
									HANDLE hDevice,				// 豸,ӦCreateDevice
									USHORT ADBuffer[],			// ڽݵû
									LONG nReadSizeWords,		// ȡADݵĳ()  
									ULONG ulStartAddr,			// RAMеʼַ
									PLONG nRetSizeWords = NULL);// ʵʷݵĳ()

    BOOL DEVAPI FAR PASCAL USB2894_ReleaseDeviceAD( HANDLE hDevice); // ֹͣADɼͷADռԴ

   	//################# ADӲ ########################	
	BOOL DEVAPI FAR PASCAL USB2894_SaveParaAD(HANDLE hDevice, PUSB2894_PARA_AD pADPara);  
    BOOL DEVAPI FAR PASCAL USB2894_LoadParaAD(HANDLE hDevice, PUSB2894_PARA_AD pADPara);
    BOOL DEVAPI FAR PASCAL USB2894_ResetParaAD(HANDLE hDevice, PUSB2894_PARA_AD pADPara); // ADָĬֵ

	//############################################################################
	BOOL DEVAPI FAR PASCAL USB2894_GetDevVersion(				// ȡ豸̼汾
									HANDLE hDevice,				// 豸,CreateDevice
									PULONG pulFmwVersion,		// ̼汾
									PULONG pulDriverVersion);	// 汾


	//############################ ̲߳ ################################
	HANDLE DEVAPI FAR PASCAL USB2894_CreateSystemEvent(void); 	// ںϵͳ¼
	BOOL DEVAPI FAR PASCAL USB2894_ReleaseSystemEvent(HANDLE hEvent); // ͷں¼

#ifdef __cplusplus
}
#endif

// Զ
#ifndef _USB2894_DRIVER_
#ifndef _WIN64
#pragma comment(lib, "USB2894_32.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB2894_32.dll...")
#pragma message("======== Successfully linked with USB2894_32.dll")
#else
#pragma comment(lib, "USB2894_64.lib")
#pragma message("======== Welcome to use our art company's products!")
#pragma message("======== Automatically linking with USB2894_64.dll...")
#pragma message("======== Successfully linked with USB2894_64.dll")
#endif

#endif

#endif; // _USB2894_DEVICE_